#include "SineWave.h"
#include <math.h>
#include <float.h>





SineWave::SineWave()
{
	m_fFreq = 1000.0;
	dK = 0;
	count = 0;
}


void SineWave::Initialize(float Frequency, int SampleRate, float Amplitude)
{
	m_fFreq = Frequency;
	m_iSampleRate = SampleRate;
	m_iPos = 0;
	m_dAmpFactor = Amplitude;
	m_iSampleValue = int (Amplitude * 32767.0);
	dK = m_fFreq * _2pi / (double)m_iSampleRate;
	count = 0;
}


int SineWave::Generate(short *data, int Samples)
{
	double      dSinVal,
				dAmpVal;

	unsigned int i,j;


	i=0;

    for(j = count;j < Samples+count; j++)
    {
        dSinVal = cos( (double)j * dK );
        dAmpVal = 32767.0 * dSinVal * m_dAmpFactor;
        
		data[i++]  = (short)dAmpVal;

    }
	count += Samples;

	if (count > m_iSampleRate)
		count %= m_iSampleRate;


	return 0;
}



