#include "squarewave.h"





SquareWave::SquareWave()
{
	m_fFreq = 1000.0;
}


void SquareWave::Initialize(float Frequency, int SampleRate, float Amplitude)
{
	m_fFreq = Frequency;
	m_iSampleRate = SampleRate;
	m_iPos = 0;
	m_iFullCycle = (int)(m_iSampleRate / m_fFreq);
	m_iHalfCycle = m_iFullCycle / 2;
	m_iSampleValue = int (Amplitude * 32767.0);
}


int SquareWave::Generate(short *data, int Samples)
{
	while (Samples--)
	{
		if (m_iPos++ < m_iHalfCycle)
			*data++ = (short)m_iSampleValue;
		else
			*data++ = (short)-m_iSampleValue;

		if (m_iPos > m_iFullCycle)
			m_iPos = 0;
	}

	return 0;
}
